let lockReconnect = false
let lock = false
let timer = false
let socket

// readyState: 0-正在连接 1-已经连接 2-连接正在关闭 3-已关闭或没连接成功

function onOpen(e, data) {
  console.log('open && send ...', data.name)
  e.target.send(data.sendData)
}

function onError(e, data) {
  console.log('error...', e, data)
}

function onClose(e, data) {
  console.log('close...', e, data)
}

function reconnect(e, data) {
  console.log('reconnect...', e, data)
  lockReconnect = true
  timer = setTimeout(() => {
    initWs(data)
    lockReconnect = false
  }, 10000)
}

export function initWs(data) {
  if (typeof WebSocket === undefined) {
    console.error('您的浏览器不支持socket')
  } else {
    socket = new WebSocket(data.url)
    // 监听socket连接open
    socket.onopen = (e) => onOpen(e, data)
    // 监听socket错误信息
    socket.onerror = (e) => onError(e, data)
    // 断开连接
    socket.onclose = (e) => onClose(e, data)
    return {
      name: data.name,
      url: data.url,
      status: data.status,
      ws: socket,
    }
  }
}
